<template>
  <view class="categoryThree">
    <view class="head">
      <view class="one">{{dataInfo.grandParentName}}<uni-icons class="right" type="right" :size="16" :color="primaryColor"></uni-icons>{{dataInfo.parentName}}<uni-icons class="right" type="right" :size="16" :color="primaryColor"></uni-icons></view>
      <text class="two ellipsis">{{dataInfo.categoryThreeObj.category}}</text>
    </view>
    <view class="body" v-if="dataInfo.list.length">
      <uni-data-checkbox v-model="dataInfo.categoryThree" :localdata="dataInfo.list" mode="list" wrap icon="right" :map="{text:'category',value:'id'}" @change="selectItem"></uni-data-checkbox>
    </view>
    <view class="zanwu" v-else>
      <text class="newicon newicon-zanwu"></text>
    </view>
    <view class="foot_common_btns">
      <button @click="goBack" type="default" class="primaryButton btn">上一级</button>
      <button @click="confirm" type="default" class="primaryButton btn">确认</button>
    </view>
  </view>
</template>

<script setup>
  import { ref, reactive} from 'vue'
  import { onLoad, onPullDownRefresh, onReachBottom } from '@dcloudio/uni-app'
  import { api_incidentcategory } from "@/http/api.js"
  import { defaultColor } from '@/static/js/theme.js'
  import { useSetTitle } from '@/share/useSetTitle.js'
  import { useLoginUserStore } from '@/stores/loginUser'
  import { useHandlerStore } from '@/stores/handler'
  import { useIncidentBuildStore } from '@/stores/incidentBuild'
  import { useGoBack } from '@/share/useGoBack.js'
  
  useSetTitle();
  const loginUserStore = useLoginUserStore();
  const handlerStore = useHandlerStore();
  const incidentBuildStore = useIncidentBuildStore();
  const { goBack }  = useGoBack();
  
  // 主题颜色
  const primaryColor = ref(defaultColor)
  
  // 数据
  const dataInfo = reactive({
    list: [],//工单列表
    idx: 0,//页码
    hasMore: true,//是否有更多数据
    incidentId: undefined,//事件ID
    paramData: {},//传参
    grandParentName: undefined,//二级故障现象名称
    parentId: undefined,//三级故障现象id
    parentName: '',//三级故障现象名称
    categoryThree: undefined,//三级故障现象-回显
    categoryThreeObj: {},//三级故障现象列表-已选择
  })
  
  // 选择
  function selectItem(e){
    dataInfo.categoryThreeObj = e.detail.data;
  }
  
  // 确认
  function confirm(){
    if(!dataInfo.categoryThree){
      uni.showToast({
      	icon: 'none',
        title: '请选择三级故障现象'
      });
      return;
    }
    dataInfo.paramData.category = dataInfo.categoryThreeObj;
    if(handlerStore.handler.type){
      handlerStore.setHandlerData(dataInfo.paramData, handlerStore.handler.type, handlerStore.handler.sign);
      uni.navigateTo({
        url: `/pages/${handlerStore.handler.type}/${handlerStore.handler.type}?incidentId=${dataInfo.incidentId}`,
      })
    } else if(incidentBuildStore.incidentBuild.type){
      incidentBuildStore.setIncidentBuildData(dataInfo.paramData, incidentBuildStore.incidentBuild.type);
      uni.navigateTo({
        url: `/pages/${incidentBuildStore.incidentBuild.type}/${incidentBuildStore.incidentBuild.type}?incidentId=${dataInfo.incidentId}`,
      })
    }
    
  }
  
  // 获取传递的数据
  function getParamData(){
    if(handlerStore.handler.type){
      dataInfo.paramData = handlerStore.handler.data || {};
    } else if(incidentBuildStore.incidentBuild.type){
      dataInfo.paramData = incidentBuildStore.incidentBuild.data || {};
    }
    dataInfo.categoryThree = dataInfo.paramData.category ? dataInfo.paramData.category.id : undefined;
    dataInfo.categoryThreeObj =  dataInfo.paramData.category || {};
    getList(0);
  }
  
  // 获取列表信息
  function getList(idx){
    uni.showLoading({
      title: "加载中",
      mask: true,
    });
    
    // dataInfo.idx = idx === undefined ? dataInfo.idx : idx;
    // if(dataInfo.idx === 0){
    //   dataInfo.list = [];
    // }

    let postData = {
      // idx: dataInfo.idx,
      // sum: 9999,
      category: {
				dutyIds:loginUserStore.loginUser.user.currentHospital.id,
        parent: {
          id: dataInfo.parentId,
        },
      }
    }
    
    // 当前所属院区或责任科室
    // if(loginUserStore.loginUser.user.duty){
    //   postData.incidentcategory.duty = loginUserStore.loginUser.user.duty.id;
    // }else if(loginUserStore.loginUser.user.branch){
    //   postData.incidentcategory.branch = loginUserStore.loginUser.user.branch.id;
    // }
    
    api_incidentcategory(postData).then(res => {
      uni.hideLoading();
      uni.stopPullDownRefresh();
      if(res.status == 200){
         dataInfo.list = res.data || [];
        // if(list.length){
        //   dataInfo.hasMore = true;
        //   dataInfo.list = dataInfo.idx === 0 ? list : dataInfo.list.concat(list);
        // }else{
        //   dataInfo.hasMore = false;
        // }
      }else{
        uni.showToast({
          icon: 'none',
          title: res.msg || '请求数据失败！'
        });
      }
    })
  }
  
  onLoad((option) => {
    dataInfo.incidentId = option.incidentId;
    dataInfo.grandParentName = option.grandParentName;
    dataInfo.parentId = option.parentId;
    dataInfo.parentName = option.parentName;
    getParamData();
  })
  
  onPullDownRefresh(() => {
    // getList(0)
  })
  
  onReachBottom(() => {
    // dataInfo.idx += 1;
    // if (dataInfo.hasMore) {
    //   getList(); // 当触底时加载更多数据
    // }
  })
</script>

<style lang="scss" scoped>
.categoryThree{
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  .head{
    height: 88rpx;
    display: flex;
    align-items: center;
    padding: 0 24rpx;
    position: fixed;
    z-index: 99;
    width: 100%;
    box-sizing: border-box;
    background: #fff;
    font-size: 26rpx;
    color: $uni-primary;
    .right{
      margin-top: 2rpx;
    }
    .two{
      flex: 1;
    }
  }
  .body{
    border-top: 1rpx solid #DEDEDE;
    margin-bottom: 140rpx;
    margin-top: 88rpx;
    font-size: 26rpx;
    .body_item{
      border-bottom: 1rpx solid #DEDEDE;
      padding: 24rpx;
    }
  }
  .zanwu{
    margin-bottom: 140rpx;
    margin-top: 88rpx;
    display: flex;
    justify-content: center;
    .newicon-zanwu{
      font-size: 256rpx;
      color: #D6D6D6;
      margin-top: 140rpx;
    }
  }
  .foot_common_btns{
    position: fixed;
    left: 0;
    bottom: 0;
    background-color: #fff;
  }
}
</style>
